Index: trunk/src/VBox/Main/src-all/ExtPackManagerImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-all/ExtPackManagerImpl.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-all/ExtPackManagerImpl.cpp	(revision 50899)
@@ -314,10 +314,7 @@
      *        dropped. */
     if (!strSavedName.equalsIgnoreCase(m->Desc.strName))
-    {
-        Utf8Str str;
-        str = "Extension pack name mismatch between the downloaded file";
-        str += "and the XML inside it (xml='%s' file='%s')";
-        return initFailed(tr(str.c_str()), m->Desc.strName.c_str(), strSavedName.c_str());
-    }
+        return initFailed(tr("Extension pack name mismatch between the downloaded file and the XML inside it (xml='%s' file='%s')"),
+                          m->Desc.strName.c_str(), strSavedName.c_str());
+
 
     m->fUsable = true;
Index: trunk/src/VBox/Main/src-all/ProgressImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-all/ProgressImpl.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-all/ProgressImpl.cpp	(revision 50899)
@@ -159,6 +159,5 @@
             uint64_t ullTimeRemaining = ullTimeTotal - ullTimeElapsed;
 
-//          Log(("Progress::GetTimeRemaining: dPercentDone %RI32, ullTimeNow =
-//          %RI64, ullTimeElapsed = %RI64, ullTimeTotal = %RI64, ullTimeRemaining = %RI64\n",
+//          Log(("Progress::GetTimeRemaining: dPercentDone %RI32, ullTimeNow = %RI64, ullTimeElapsed = %RI64, ullTimeTotal = %RI64, ullTimeRemaining = %RI64\n",
 //          (uint32_t)dPercentDone, ullTimeNow, ullTimeElapsed, ullTimeTotal, ullTimeRemaining));
 
@@ -444,6 +443,5 @@
                        OUT_GUID aId /* = NULL */)
 {
-    Utf8Str str = "aDescription=\"%s\", cOperations=%d, ulTotalOperationsWeight=%d, ";
-    LogFlowThisFunc((str.c_str(),
+    LogFlowThisFunc(("aDescription=\"%ls\", cOperations=%d, ulTotalOperationsWeight=%d, bstrFirstOperationDescription=\"%ls\", ulFirstOperationWeight=%d\n",
                      aDescription.c_str(),
                      cOperations,
@@ -908,9 +906,6 @@
     m_ulOperationPercent = 0;
 
-    Utf8Str str;
-    str = "Progress::setNextOperation(%s): ulNextOperationsWeight = %d; m_ulCurrentOperation is now %d,";
-    str += "m_ulOperationsCompletedWeight is now %d\n";
-    Log((str.c_str(), m_operationDescription.c_str(), aNextOperationsWeight, m_ulCurrentOperation,
-         m_ulOperationsCompletedWeight));
+    Log(("Progress::setNextOperation(%s): aNextOperationsWeight = %d; m_ulCurrentOperation is now %d, m_ulOperationsCompletedWeight is now %d\n",
+         m_operationDescription.c_str(), aNextOperationsWeight, m_ulCurrentOperation, m_ulOperationsCompletedWeight));
 
     /* wake up all waiting threads */
Index: trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-client/GuestProcessImpl.cpp	(revision 50899)
@@ -487,8 +487,6 @@
         if (RT_UNLIKELY(mData.mPID != uPID))
         {
-            Utf8Str str;
-            str  = "Stale guest process (PID=%RU32) sent data to newly started";
-            str += " process (pProcesS=%p, PID=%RU32, status=%RU32)\n";
-            LogFlowFunc((str.c_str(), uPID, this, mData.mPID, mData.mStatus));
+            LogFlowFunc(("Stale guest process (PID=%RU32) sent data to a newly started process (pProcesS=%p, PID=%RU32, status=%RU32)\n",
+                         uPID, this, mData.mPID, mData.mStatus));
             rc = VERR_NOT_FOUND;
         }
@@ -1380,7 +1378,6 @@
     {
         waitResult = ProcessWaitResult_Error;
-        Utf8Str str;
-        str  = "No error rc (%Rrc) set when guest process indicated an error\n";
-        AssertMsg(RT_FAILURE(mData.mLastError), (str.c_str(), mData.mLastError));
+        AssertMsg(RT_FAILURE(mData.mLastError),
+                             ("No error rc (%Rrc) set when guest process indicated an error\n", mData.mLastError));
         if (pGuestRc)
             *pGuestRc = mData.mLastError; /* Return last set error. */
@@ -1666,9 +1663,7 @@
                               void *pvData, size_t cbData, uint32_t uTimeoutMS, uint32_t *puWritten, int *pGuestRc)
 {
-    Utf8Str str;
-    str = "uPID=%RU32, uHandle=%RU32, uFlags=%RU32, pvData=%p, cbData=%RU32, uTimeoutMS=%RU32, puWritten=%p, pGuestRc=%p\n";
-    LogFlowThisFunc((str.c_str(), mData.mPID, uHandle, uFlags, pvData, cbData, uTimeoutMS, puWritten, pGuestRc));
+    LogFlowThisFunc(("uPID=%RU32, uHandle=%RU32, uFlags=%RU32, pvData=%p, cbData=%RU32, uTimeoutMS=%RU32, puWritten=%p, pGuestRc=%p\n",
+                     mData.mPID, uHandle, uFlags, pvData, cbData, uTimeoutMS, puWritten, pGuestRc));
     /* All is optional. There can be 0 byte writes. */
-
     AutoWriteLock alock(this COMMA_LOCKVAL_SRC_POS);
 
Index: trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-client/GuestSessionImpl.cpp	(revision 50899)
@@ -2156,10 +2156,7 @@
     if (   mData.mProtocolVersion < 2
         && s_gctrlLegacyWarning++ < 3) /** @todo Find a bit nicer text. */
-    {
-        Utf8Str str;
-        str = "Warning: Guest Additions are older (%ld.%ld) than host";
-        str += " capabilities for guest control, please upgrade them. Using protocol version %ld now\n";
-        LogRel((tr(str.c_str()), uVBoxMajor, uVBoxMinor, mData.mProtocolVersion));
-    }
+        LogRel((tr("Warning: Guest Additions are older (%ld.%ld) than host capabilities for guest control, please upgrade them. Using protocol version %ld now\n"),
+                uVBoxMajor, uVBoxMinor, mData.mProtocolVersion));
+
     return VINF_SUCCESS;
 }
Index: trunk/src/VBox/Main/src-server/ApplianceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImpl.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-server/ApplianceImpl.cpp	(revision 50899)
@@ -937,9 +937,6 @@
         }
     }
-
-    Utf8Str str;
-    str = "Setting up progress object: ulTotalMB = %d, cDisks = %d, => cOperations = %d,";
-    str +=  "ulTotalOperationsWeight = %d, m->ulWeightForXmlOperation = %d\n";
-    Log((str.c_str(), m->ulTotalDisksMB, m->cDisks, cOperations, ulTotalOperationsWeight, m->ulWeightForXmlOperation));
+    Log(("Setting up progress object: ulTotalMB = %d, cDisks = %d, => cOperations = %d, ulTotalOperationsWeight = %d, m->ulWeightForXmlOperation = %d\n",
+         m->ulTotalDisksMB, m->cDisks, cOperations, ulTotalOperationsWeight, m->ulWeightForXmlOperation));
 
     rc = pProgress->init(mVirtualBox, static_cast<IAppliance*>(this),
Index: trunk/src/VBox/Main/src-server/MachineImplCloneVM.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MachineImplCloneVM.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-server/MachineImplCloneVM.cpp	(revision 50899)
@@ -677,5 +677,5 @@
                         pParent->i_getPreferredDiffFormat(),
                         Utf8StrFmt("%s%c", strSnapshotFolder.c_str(), RTPATH_DELIMITER),
-                        Guid::Empty /* empty media registry */);
+                                   Guid::Empty /* empty media registry */);
         if (FAILED(rc)) throw rc;
 
@@ -1037,5 +1037,5 @@
         /* The absolute name of the snapshot folder. */
         strTrgSnapshotFolder = Utf8StrFmt("%s%c%s", strTrgMachineFolder.c_str(), RTPATH_DELIMITER,
-                                                    trgMCF.machineUserData.strSnapshotFolder.c_str());
+                                          trgMCF.machineUserData.strSnapshotFolder.c_str());
 
         /* Should we rename the disk names. */
@@ -1168,5 +1168,5 @@
                             if (strSrcTest == strOldVMName)
                                 strNewName = Utf8StrFmt("%s%s", trgMCF.machineUserData.strName.c_str(),
-                                                                RTPathSuffix(Utf8Str(bstrSrcName).c_str()));
+                                                        RTPathSuffix(Utf8Str(bstrSrcName).c_str()));
                             else if (   strSrcTest.startsWith("{")
                                      && strSrcTest.endsWith("}"))
@@ -1177,5 +1177,5 @@
                                 if (temp_guid.isValid() && !temp_guid.isZero())
                                     strNewName = Utf8StrFmt("%s%s", newId.toStringCurly().c_str(),
-                                                                    RTPathSuffix(strNewName.c_str()));
+                                                            RTPathSuffix(strNewName.c_str()));
                             }
                             else
@@ -1350,5 +1350,5 @@
                 throw p->setError(VBOX_E_IPRT_ERROR,
                                   p->tr("Could not create snapshots folder '%s' (%Rrc)"),
-                                  strTrgSnapshotFolder.c_str(), vrc);
+                                        strTrgSnapshotFolder.c_str(), vrc);
         }
         /* Clone all save state files. */
@@ -1361,5 +1361,5 @@
             /* Move to next sub-operation. */
             rc = d->pProgress->SetNextOperation(BstrFmt(p->tr("Copy save state file '%s' ..."),
-                                                RTPathFilename(sst.strSaveStateFile.c_str())).raw(), sst.uWeight);
+                                                        RTPathFilename(sst.strSaveStateFile.c_str())).raw(), sst.uWeight);
             if (FAILED(rc)) throw rc;
             /* Copy the file only if it was not copied already. */
Index: trunk/src/VBox/Main/src-server/SnapshotImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 50899)
@@ -1422,9 +1422,7 @@
         && mData->mCurrentSnapshot->i_getDepth() >= SETTINGS_SNAPSHOT_DEPTH_MAX)
     {
-        Utf8Str str;
-        str = "Cannot take another snapshot for machine '%s', because it exceeds the maximum";
-        str += "snapshot depth limit. Please delete some earlier snapshot which you no longer need";
+
         return setError(VBOX_E_INVALID_OBJECT_STATE,
-                        tr(str.c_str()),
+                        tr("Cannot take another snapshot for machine '%s', because it exceeds the maximum snapshot depth limit. Please delete some earlier snapshot which you no longer need"),
                         mUserData->s.strName.c_str());
     }
@@ -2118,23 +2116,15 @@
     size_t childrenCount = pSnapshot->i_getChildrenCount();
     if (childrenCount > 1)
-    {
-        str = "Snapshot '%s' of the machine '%s' cannot be deleted, because it has %d child snapshots,";
-        str += "which is more than the one snapshot allowed for deletion";
         return setError(VBOX_E_INVALID_OBJECT_STATE,
-                        tr(str.c_str()),
+                        tr("Snapshot '%s' of the machine '%s' cannot be deleted, because it has %d child snapshots, which is more than the one snapshot allowed for deletion"),
                         pSnapshot->i_getName().c_str(),
                         mUserData->s.strName.c_str(),
                         childrenCount);
-    }
 
     if (pSnapshot == mData->mCurrentSnapshot && childrenCount >= 1)
-    {
-        str = "Snapshot '%s' of the machine '%s' cannot be deleted, because it is the current";
-        str += "snapshot and has one child snapshot";
         return setError(VBOX_E_INVALID_OBJECT_STATE,
-                        tr(str.c_str()),
+                        tr("Snapshot '%s' of the machine '%s' cannot be deleted, because it is the current snapshot and has one child snapshot"),
                         pSnapshot->i_getName().c_str(),
                         mUserData->s.strName.c_str());
-    }
 
     /* If the snapshot being deleted is the current one, ensure current
Index: trunk/src/VBox/Main/src-server/generic/NetIf-generic.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/generic/NetIf-generic.cpp	(revision 50898)
+++ trunk/src/VBox/Main/src-server/generic/NetIf-generic.cpp	(revision 50899)
@@ -258,6 +258,5 @@
                                                        COM_IIDOF(IHostNetworkInterface),
                                                        HostNetworkInterface::getStaticComponentName(),
-                                                       "Failed to get config info for %s (as reported by '"
-                                                       VBOXNETADPCTL_NAME " add')\n", szBuf);
+                                                       "Failed to get config info for %s (as reported by '" VBOXNETADPCTL_NAME " add')\n", szBuf);
                         }
                         else
@@ -289,6 +288,5 @@
                                                COM_IIDOF(IHostNetworkInterface),
                                                HostNetworkInterface::getStaticComponentName(),
-                                               "Failed to execute '" VBOXNETADPCTL_NAME
-                                               " add' (exit status: %d). Check permissions!", rc);
+                                               "Failed to execute '" VBOXNETADPCTL_NAME " add' (exit status: %d). Check permissions!", rc);
                     pclose(fp);
                 }