Index: trunk/src/VBox/Main/src-client/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 50908)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 50914)
@@ -618,5 +618,5 @@
     /* Let the extension packs have a go at things (hold no locks). */
     if (SUCCEEDED(rc))
-        mptrExtPackManager->callAllConsoleReadyHooks(this);
+        mptrExtPackManager->i_callAllConsoleReadyHooks(this);
 #endif
 
@@ -5820,5 +5820,5 @@
     {
 #ifdef VBOX_WITH_EXTPACK
-        vrc = mptrExtPackManager->callAllVmPowerOnHooks(this, VMR3GetVM(ptrVM.rawUVM()));
+        vrc = mptrExtPackManager->i_callAllVmPowerOnHooks(this, VMR3GetVM(ptrVM.rawUVM()));
 #else
         vrc = VINF_SUCCESS;
@@ -6693,5 +6693,5 @@
 
 #ifdef VBOX_WITH_EXTPACK
-        mptrExtPackManager->dumpAllToReleaseLog();
+        mptrExtPackManager->i_dumpAllToReleaseLog();
 #endif
 
@@ -7092,5 +7092,5 @@
         vrc = VMR3PowerOff(pUVM);
 #ifdef VBOX_WITH_EXTPACK
-        mptrExtPackManager->callAllVmPowerOffHooks(this, VMR3GetVM(pUVM));
+        mptrExtPackManager->i_callAllVmPowerOffHooks(this, VMR3GetVM(pUVM));
 #endif
         alock.acquire();
@@ -9126,5 +9126,5 @@
                             /* Start/Resume the VM execution */
 #ifdef VBOX_WITH_EXTPACK
-                            vrc = pConsole->mptrExtPackManager->callAllVmPowerOnHooks(pConsole, pVM);
+                            vrc = pConsole->mptrExtPackManager->i_callAllVmPowerOnHooks(pConsole, pVM);
 #endif
                             if (RT_SUCCESS(vrc))
@@ -9139,5 +9139,5 @@
                         int vrc2 = VMR3PowerOff(pConsole->mpUVM); AssertLogRelRC(vrc2);
 #ifdef VBOX_WITH_EXTPACK
-                        pConsole->mptrExtPackManager->callAllVmPowerOffHooks(pConsole, pVM);
+                        pConsole->mptrExtPackManager->i_callAllVmPowerOffHooks(pConsole, pVM);
 #endif
                     }
@@ -9154,5 +9154,5 @@
                         int vrc2 = VMR3PowerOff(pConsole->mpUVM); AssertLogRelRC(vrc2);
 #ifdef VBOX_WITH_EXTPACK
-                        pConsole->mptrExtPackManager->callAllVmPowerOffHooks(pConsole, pVM);
+                        pConsole->mptrExtPackManager->i_callAllVmPowerOffHooks(pConsole, pVM);
 #endif
                     }
@@ -9187,5 +9187,5 @@
                             /* Power on the FT enabled VM. */
 #ifdef VBOX_WITH_EXTPACK
-                            vrc = pConsole->mptrExtPackManager->callAllVmPowerOnHooks(pConsole, pVM);
+                            vrc = pConsole->mptrExtPackManager->i_callAllVmPowerOnHooks(pConsole, pVM);
 #endif
                             if (RT_SUCCESS(vrc))
@@ -9210,5 +9210,5 @@
                     /* Power on the VM (i.e. start executing) */
 #ifdef VBOX_WITH_EXTPACK
-                    vrc = pConsole->mptrExtPackManager->callAllVmPowerOnHooks(pConsole, pVM);
+                    vrc = pConsole->mptrExtPackManager->i_callAllVmPowerOnHooks(pConsole, pVM);
 #endif
                     if (RT_SUCCESS(vrc))
Index: trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp	(revision 50908)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl2.cpp	(revision 50914)
@@ -628,5 +628,5 @@
 # ifdef VBOX_WITH_EXTPACK
     static const char *s_pszPCIRawExtPackName = "Oracle VM VirtualBox Extension Pack";
-    if (!mptrExtPackManager->isExtPackUsable(s_pszPCIRawExtPackName))
+    if (!mptrExtPackManager->i_isExtPackUsable(s_pszPCIRawExtPackName))
         /* Always fatal! */
         return VMR3SetError(pUVM, VERR_NOT_FOUND, RT_SRC_POS,
@@ -1752,5 +1752,5 @@
                     static const char *s_pszUsbExtPackName = "Oracle VM VirtualBox Extension Pack";
 # ifdef VBOX_WITH_EXTPACK
-                    if (mptrExtPackManager->isExtPackUsable(s_pszUsbExtPackName))
+                    if (mptrExtPackManager->i_isExtPackUsable(s_pszUsbExtPackName))
 # endif
                     {
@@ -1798,5 +1798,5 @@
                     static const char *s_pszUsbExtPackName = "Oracle VM VirtualBox Extension Pack";
 # ifdef VBOX_WITH_EXTPACK
-                    if (mptrExtPackManager->isExtPackUsable(s_pszUsbExtPackName))
+                    if (mptrExtPackManager->i_isExtPackUsable(s_pszUsbExtPackName))
 # endif
                     {
@@ -3037,5 +3037,5 @@
     {
         pAlock->release();
-        rc = mptrExtPackManager->callAllVmConfigureVmmHooks(this, pVM);
+        rc = mptrExtPackManager->i_callAllVmConfigureVmmHooks(this, pVM);
         pAlock->acquire();
     }
Index: trunk/src/VBox/Main/src-client/ConsoleVRDPServer.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleVRDPServer.cpp	(revision 50908)
+++ trunk/src/VBox/Main/src-client/ConsoleVRDPServer.cpp	(revision 50914)
@@ -1516,5 +1516,5 @@
 #ifdef VBOX_WITH_EXTPACK
         ExtPackManager *pExtPackMgr = mConsole->getExtPackManager();
-        vrc = pExtPackMgr->getVrdeLibraryPathForExtPack(&strExtPack, &strVrdeLibrary);
+        vrc = pExtPackMgr->i_getVrdeLibraryPathForExtPack(&strExtPack, &strVrdeLibrary);
 #else
         vrc = VERR_FILE_NOT_FOUND;
Index: trunk/src/VBox/Main/src-client/xpcom/module.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/xpcom/module.cpp	(revision 50908)
+++ trunk/src/VBox/Main/src-client/xpcom/module.cpp	(revision 50914)
@@ -84,8 +84,4 @@
 // NS_DECL_CLASSINFO(ExtPackFile)
 // NS_IMPL_THREADSAFE_ISUPPORTS2_CI(ExtPackFile, IExtPackFile, IExtPackBase)
-NS_DECL_CLASSINFO(ExtPack)
-NS_IMPL_THREADSAFE_ISUPPORTS2_CI(ExtPack, IExtPack, IExtPackBase)
-NS_DECL_CLASSINFO(ExtPackManager)
-NS_IMPL_THREADSAFE_ISUPPORTS1_CI(ExtPackManager, IExtPackManager)
  #endif
 