Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 50936)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2.qrc	(revision 50939)
@@ -105,4 +105,20 @@
         <file alias="cd_read_16px.png">images/cd_read_16px.png</file>
         <file alias="cd_write_16px.png">images/cd_write_16px.png</file>
+        <file alias="cd_copy_16px.png">images/cd_copy_16px.png</file>
+        <file alias="cd_copy_disabled_16px.png">images/cd_copy_disabled_16px.png</file>
+        <file alias="cd_copy_22px.png">images/cd_copy_22px.png</file>
+        <file alias="cd_copy_disabled_22px.png">images/cd_copy_disabled_22px.png</file>
+        <file alias="cd_modify_16px.png">images/cd_modify_16px.png</file>
+        <file alias="cd_modify_disabled_16px.png">images/cd_modify_disabled_16px.png</file>
+        <file alias="cd_modify_22px.png">images/cd_modify_22px.png</file>
+        <file alias="cd_modify_disabled_22px.png">images/cd_modify_disabled_22px.png</file>
+        <file alias="cd_release_16px.png">images/cd_release_16px.png</file>
+        <file alias="cd_release_disabled_16px.png">images/cd_release_disabled_16px.png</file>
+        <file alias="cd_release_22px.png">images/cd_release_22px.png</file>
+        <file alias="cd_release_disabled_22px.png">images/cd_release_disabled_22px.png</file>
+        <file alias="cd_remove_16px.png">images/cd_remove_16px.png</file>
+        <file alias="cd_remove_disabled_16px.png">images/cd_remove_disabled_16px.png</file>
+        <file alias="cd_remove_22px.png">images/cd_remove_22px.png</file>
+        <file alias="cd_remove_disabled_22px.png">images/cd_remove_disabled_22px.png</file>
         <file alias="cd_unmount_16px.png">images/cd_unmount_16px.png</file>
         <file alias="cd_unmount_disabled_16px.png">images/cd_unmount_disabled_16px.png</file>
@@ -117,4 +133,20 @@
         <file alias="fd_add_16px.png">images/fd_add_16px.png</file>
         <file alias="fd_add_disabled_16px.png">images/fd_add_disabled_16px.png</file>
+        <file alias="fd_copy_16px.png">images/fd_copy_16px.png</file>
+        <file alias="fd_copy_disabled_16px.png">images/fd_copy_disabled_16px.png</file>
+        <file alias="fd_copy_22px.png">images/fd_copy_22px.png</file>
+        <file alias="fd_copy_disabled_22px.png">images/fd_copy_disabled_22px.png</file>
+        <file alias="fd_modify_16px.png">images/fd_modify_16px.png</file>
+        <file alias="fd_modify_disabled_16px.png">images/fd_modify_disabled_16px.png</file>
+        <file alias="fd_modify_22px.png">images/fd_modify_22px.png</file>
+        <file alias="fd_modify_disabled_22px.png">images/fd_modify_disabled_22px.png</file>
+        <file alias="fd_release_16px.png">images/fd_release_16px.png</file>
+        <file alias="fd_release_disabled_16px.png">images/fd_release_disabled_16px.png</file>
+        <file alias="fd_release_22px.png">images/fd_release_22px.png</file>
+        <file alias="fd_release_disabled_22px.png">images/fd_release_disabled_22px.png</file>
+        <file alias="fd_remove_16px.png">images/fd_remove_16px.png</file>
+        <file alias="fd_remove_disabled_16px.png">images/fd_remove_disabled_16px.png</file>
+        <file alias="fd_remove_22px.png">images/fd_remove_22px.png</file>
+        <file alias="fd_remove_disabled_22px.png">images/fd_remove_disabled_22px.png</file>
         <file alias="mouse_16px.png">images/mouse_16px.png</file>
         <file alias="mouse_disabled_16px.png">images/mouse_disabled_16px.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 50936)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 50939)
@@ -845,4 +845,7 @@
     if (qobject_cast<QTreeWidget*>(focusWidget()))
         pTreeWidget->setFocus();
+
+    /* Update action icons: */
+    updateActionIcons();
 
     /* Re-fetch currently chosen medium-item: */
@@ -1006,7 +1009,4 @@
         /* Configure copy-action: */
         m_pActionCopy->setShortcut(QKeySequence("Ctrl+O"));
-        m_pActionCopy->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
-                                                       ":/hd_copy_22px.png", ":/hd_copy_16px.png",
-                                                       ":/hd_copy_disabled_22px.png", ":/hd_copy_disabled_16px.png"));
         connect(m_pActionCopy, SIGNAL(triggered()), this, SLOT(sltCopyMedium()));
     }
@@ -1017,7 +1017,4 @@
         /* Configure modify-action: */
         m_pActionModify->setShortcut(QKeySequence("Ctrl+Space"));
-        m_pActionModify->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
-                                                         ":/hd_modify_22px.png", ":/hd_modify_16px.png",
-                                                         ":/hd_modify_disabled_22px.png", ":/hd_modify_disabled_16px.png"));
         connect(m_pActionModify, SIGNAL(triggered()), this, SLOT(sltModifyMedium()));
     }
@@ -1028,7 +1025,4 @@
         /* Configure remove-action: */
         m_pActionRemove->setShortcut(QKeySequence(QKeySequence::Delete));
-        m_pActionRemove->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
-                                                         ":/hd_remove_22px.png", ":/hd_remove_16px.png",
-                                                         ":/hd_remove_disabled_22px.png", ":/hd_remove_disabled_16px.png"));
         connect(m_pActionRemove, SIGNAL(triggered()), this, SLOT(sltRemoveMedium()));
     }
@@ -1039,7 +1033,4 @@
         /* Configure release-action: */
         m_pActionRelease->setShortcut(QKeySequence("Ctrl+L"));
-        m_pActionRelease->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
-                                                          ":/hd_release_22px.png", ":/hd_release_16px.png",
-                                                          ":/hd_release_disabled_22px.png", ":/hd_release_disabled_16px.png"));
         connect(m_pActionRelease, SIGNAL(triggered()), this, SLOT(sltReleaseMedium()));
     }
@@ -1050,9 +1041,9 @@
         /* Configure refresh-action: */
         m_pActionRefresh->setShortcut(QKeySequence(QKeySequence::Refresh));
-        m_pActionRefresh->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
-                                                          ":/refresh_22px.png", ":/refresh_16px.png",
-                                                          ":/refresh_disabled_22px.png", ":/refresh_disabled_16px.png"));
         connect(m_pActionRefresh, SIGNAL(triggered()), this, SLOT(sltRefreshAll()));
     }
+
+    /* Update action icons: */
+    updateActionIcons();
 }
 
@@ -1356,4 +1347,41 @@
 }
 
+void UIMediumManager::updateActionIcons()
+{
+    QString strPrefix;
+    switch (currentMediumType())
+    {
+        case UIMediumType_HardDisk: strPrefix = "hd"; break;
+        case UIMediumType_DVD:      strPrefix = "cd"; break;
+        case UIMediumType_Floppy:   strPrefix = "fd"; break;
+        default: break;
+    }
+    AssertReturnVoid(!strPrefix.isNull());
+    m_pActionCopy->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
+                                                   QString(":/%1_copy_22px.png").arg(strPrefix),
+                                                   QString(":/%1_copy_16px.png").arg(strPrefix),
+                                                   QString(":/%1_copy_disabled_22px.png").arg(strPrefix),
+                                                   QString(":/%1_copy_disabled_16px.png").arg(strPrefix)));
+    m_pActionModify->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
+                                                     QString(":/%1_modify_22px.png").arg(strPrefix),
+                                                     QString(":/%1_modify_16px.png").arg(strPrefix),
+                                                     QString(":/%1_modify_disabled_22px.png").arg(strPrefix),
+                                                     QString(":/%1_modify_disabled_16px.png").arg(strPrefix)));
+    m_pActionRemove->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
+                                                     QString(":/%1_remove_22px.png").arg(strPrefix),
+                                                     QString(":/%1_remove_16px.png").arg(strPrefix),
+                                                     QString(":/%1_remove_disabled_22px.png").arg(strPrefix),
+                                                     QString(":/%1_remove_disabled_16px.png").arg(strPrefix)));
+    m_pActionRelease->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
+                                                      QString(":/%1_release_22px.png").arg(strPrefix),
+                                                      QString(":/%1_release_16px.png").arg(strPrefix),
+                                                      QString(":/%1_release_disabled_22px.png").arg(strPrefix),
+                                                      QString(":/%1_release_disabled_16px.png").arg(strPrefix)));
+    if (m_pActionRefresh->icon().isNull())
+        m_pActionRefresh->setIcon(UIIconPool::iconSetFull(QSize(22, 22), QSize(16, 16),
+                                                          ":/refresh_22px.png", ":/refresh_16px.png",
+                                                          ":/refresh_disabled_22px.png", ":/refresh_disabled_16px.png"));
+}
+
 void UIMediumManager::updateTabIcons(UIMediumItem *pMediumItem, Action action)
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 50936)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 50939)
@@ -145,4 +145,6 @@
     /** Update actions according currently chosen item. */
     void updateActions();
+    /** Update action icons according currently chosen tab. */
+    void updateActionIcons();
     /** Update tab icons according last @a action happened with @a pItem. */
     void updateTabIcons(UIMediumItem *pItem, Action action);